/* puzzle-view.c generated by valac 0.56.17, the Vala compiler
 * generated from puzzle-view.vala, do not modify */

/*
   This file is part of GNOME Klotski.

   Copyright (C) 2010-2013 Robert Ancell

   GNOME Klotski is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Klotski is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Klotski.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <librsvg/rsvg.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <stdio.h>
#include <stdlib.h>
#include <gdk/gdk.h>
#include <string.h>

#define PUZZLE_VIEW_SPACE_OFFSET 4
#define PUZZLE_VIEW_SPACE_PADDING 5
#define PUZZLE_VIEW_THEME_OVERLAY_SIZE 8
#define PUZZLE_VIEW_THEME_TILE_SEGMENTS 27
#define PUZZLE_VIEW_THEME_TILE_CENTER 14
#define PUZZLE_VIEW_THEME_TILE_SIZE 34
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PUZZLE_VIEW (puzzle_view_get_type ())
#define PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_VIEW, PuzzleView))
#define PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_VIEW, PuzzleViewClass))
#define IS_PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_VIEW))
#define IS_PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_VIEW))
#define PUZZLE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_VIEW, PuzzleViewClass))

typedef struct _PuzzleView PuzzleView;
typedef struct _PuzzleViewClass PuzzleViewClass;
typedef struct _PuzzleViewPrivate PuzzleViewPrivate;

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
enum  {
	PUZZLE_VIEW_0_PROPERTY,
	PUZZLE_VIEW_PUZZLE_PROPERTY,
	PUZZLE_VIEW_NUM_PROPERTIES
};
static GParamSpec* puzzle_view_properties[PUZZLE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _PuzzlePrivate PuzzlePrivate;

struct _PuzzleView {
	GtkDrawingArea parent_instance;
	PuzzleViewPrivate * priv;
};

struct _PuzzleViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _PuzzleViewPrivate {
	gint render_size;
	guint8 piece_x;
	guint8 piece_y;
	gboolean piece_unmoved;
	gchar _piece_id;
	gchar last_piece_id;
	gdouble kx;
	gdouble ky;
	gboolean tiles_handle_init_done;
	RsvgHandle* tiles_handle;
	GFile* image_file;
	cairo_surface_t* surface;
	gboolean puzzle_init_done;
	Puzzle* _puzzle;
	GtkStyleContext* style_context;
	GtkEventControllerMotion* motion_controller;
	GtkGestureMultiPress* click_controller;
};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
	gchar* map;
	gint map_length1;
	gint _map_size_;
	gchar* move_map;
	gint move_map_length1;
	gint _move_map_size_;
	gchar* orig_map;
	gint orig_map_length1;
	gint _orig_map_size_;
	gchar* lastmove_map;
	gint lastmove_map_length1;
	gint _lastmove_map_size_;
	gchar* undomove_map;
	gint undomove_map_length1;
	gint _undomove_map_size_;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

static gint PuzzleView_private_offset;
static gpointer puzzle_view_parent_class = NULL;

VALA_EXTERN GType puzzle_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleView, g_object_unref)
VALA_EXTERN GType puzzle_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
static void puzzle_view_load_image (PuzzleView* self);
static gboolean puzzle_view_real_draw (GtkWidget* base,
                                cairo_t* cr);
static gint puzzle_view_get_tile_size (PuzzleView* self);
static Puzzle* puzzle_view_get_puzzle (PuzzleView* self);
VALA_EXTERN guint8 puzzle_get_width (Puzzle* self);
VALA_EXTERN guint8 puzzle_get_height (Puzzle* self);
static void puzzle_view_draw_square (PuzzleView* self,
                              cairo_t* cr,
                              guint8 x,
                              guint8 y,
                              gdouble kx,
                              gdouble ky);
static gchar puzzle_view_get_piece_id (PuzzleView* self);
VALA_EXTERN gchar puzzle_get_piece_id (Puzzle* self,
                           gchar* src,
                           gint src_length1,
                           guint8 x,
                           guint8 y);
VALA_EXTERN gint puzzle_get_piece_nr (Puzzle* self,
                          guint8 x,
                          guint8 y);
static void puzzle_view_init_mouse (PuzzleView* self);
static inline void puzzle_view_on_motion (GtkEventControllerMotion* _motion_controller,
                            gdouble event_x,
                            gdouble event_y);
static void _puzzle_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static inline void puzzle_view_on_click (GtkGestureMultiPress* _click_controller,
                           gint n_press,
                           gdouble event_x,
                           gdouble event_y);
static void _puzzle_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self);
static inline void puzzle_view_on_release (GtkGestureMultiPress* _click_controller,
                             gint n_press,
                             gdouble event_x,
                             gdouble event_y);
static void _puzzle_view_on_release_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self);
VALA_EXTERN gboolean puzzle_game_over (Puzzle* self);
static void puzzle_view_set_piece_id (PuzzleView* self,
                               gchar value);
VALA_EXTERN gboolean puzzle_is_static_tile (gchar id);
static void puzzle_view_validate_move (PuzzleView* self);
VALA_EXTERN gboolean puzzle_can_be_moved (Puzzle* self,
                              gchar id);
static gchar* _vala_array_dup7 (gchar* self,
                         gssize length);
VALA_EXTERN gboolean puzzle_mapcmp (Puzzle* self,
                        gchar* m1,
                        gint m1_length1,
                        gchar* m2,
                        gint m2_length1);
static gchar* _vala_array_dup8 (gchar* self,
                         gssize length);
VALA_EXTERN guint16 puzzle_get_moves (Puzzle* self);
VALA_EXTERN void puzzle_set_moves (Puzzle* self,
                       guint16 value);
static gchar* _vala_array_dup9 (gchar* self,
                         gssize length);
VALA_EXTERN gboolean puzzle_move_piece (Puzzle* self,
                            gchar id,
                            guint8 x1,
                            guint8 y1,
                            guint8 x2,
                            guint8 y2);
VALA_EXTERN PuzzleView* puzzle_view_new (void);
VALA_EXTERN PuzzleView* puzzle_view_construct (GType object_type);
VALA_EXTERN void puzzle_view_set_puzzle (PuzzleView* self,
                             Puzzle* value);
static void _gtk_widget_queue_draw_puzzle_changed (Puzzle* _sender,
                                            gpointer self);
static GObject * puzzle_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void puzzle_view_finalize (GObject * obj);
static GType puzzle_view_get_type_once (void);
static void _vala_puzzle_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_puzzle_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
puzzle_view_get_instance_private (PuzzleView* self)
{
	return G_STRUCT_MEMBER_P (self, PuzzleView_private_offset);
}

static void
puzzle_view_load_image (PuzzleView* self)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 101 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/puzzle-view.vala"
	_tmp0_ = g_file_new_for_uri ("resource:///org/gnome/Klotski/ui/assets.svg");
#line 103 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->image_file);
#line 103 "../src/puzzle-view.vala"
	self->priv->image_file = _tmp0_;
#line 269 "puzzle-view.c"
	{
		RsvgHandle* _tmp1_ = NULL;
		GFile* _tmp2_;
		RsvgHandle* _tmp3_;
		RsvgHandle* _tmp4_;
#line 107 "../src/puzzle-view.vala"
		_tmp2_ = self->priv->image_file;
#line 107 "../src/puzzle-view.vala"
		_tmp3_ = rsvg_handle_new_from_gfile_sync (_tmp2_, RSVG_HANDLE_FLAGS_NONE, NULL, &_inner_error0_);
#line 107 "../src/puzzle-view.vala"
		_tmp1_ = _tmp3_;
#line 107 "../src/puzzle-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "puzzle-view.c"
			goto __catch0_g_error;
		}
#line 107 "../src/puzzle-view.vala"
		_tmp4_ = _tmp1_;
#line 107 "../src/puzzle-view.vala"
		_tmp1_ = NULL;
#line 107 "../src/puzzle-view.vala"
		_g_object_unref0 (self->priv->tiles_handle);
#line 107 "../src/puzzle-view.vala"
		self->priv->tiles_handle = _tmp4_;
#line 105 "../src/puzzle-view.vala"
		_g_object_unref0 (_tmp1_);
#line 296 "puzzle-view.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 105 "../src/puzzle-view.vala"
		e = _inner_error0_;
#line 105 "../src/puzzle-view.vala"
		_inner_error0_ = NULL;
#line 118 "../src/puzzle-view.vala"
		_tmp5_ = stderr;
#line 118 "../src/puzzle-view.vala"
		_tmp6_ = e;
#line 118 "../src/puzzle-view.vala"
		_tmp7_ = _tmp6_->message;
#line 118 "../src/puzzle-view.vala"
		fprintf (_tmp5_, "%s %s\n", "Error in puzzle-view.vala load image:", _tmp7_);
#line 119 "../src/puzzle-view.vala"
		exit (EXIT_FAILURE);
#line 105 "../src/puzzle-view.vala"
		_g_error_free0 (e);
#line 321 "puzzle-view.c"
	}
	__finally0:
#line 105 "../src/puzzle-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/puzzle-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/puzzle-view.vala"
		g_clear_error (&_inner_error0_);
#line 105 "../src/puzzle-view.vala"
		return;
#line 332 "puzzle-view.c"
	}
#line 121 "../src/puzzle-view.vala"
	self->priv->tiles_handle_init_done = TRUE;
#line 336 "puzzle-view.c"
}

static gboolean
puzzle_view_real_draw (GtkWidget* base,
                       cairo_t* cr)
{
	PuzzleView * self;
	gint _tmp0_;
	gint _tmp1_;
	GtkStyleContext* _tmp15_;
	GtkStyleContext* _tmp16_;
	GdkRGBA fg = {0};
	GtkStyleContext* _tmp17_;
	GdkRGBA _tmp18_ = {0};
	GdkRGBA bg = {0};
	GtkStyleContext* _tmp19_;
	GdkRGBA _tmp20_ = {0};
	GtkStyleContext* _tmp21_;
	GdkRGBA _tmp22_;
	gint width = 0;
	gint height = 0;
	GdkRGBA _tmp23_;
	gdouble kwidth = 0.0;
	Puzzle* _tmp24_;
	Puzzle* _tmp25_;
	guint8 _tmp26_;
	guint8 _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gdouble kheight = 0.0;
	Puzzle* _tmp30_;
	Puzzle* _tmp31_;
	guint8 _tmp32_;
	guint8 _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gboolean result;
#line 124 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 124 "../src/puzzle-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 126 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_tile_size (self);
#line 126 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 126 "../src/puzzle-view.vala"
	if (_tmp1_ != self->priv->render_size) {
#line 384 "puzzle-view.c"
		gint _tmp13_;
		gint _tmp14_;
#line 128 "../src/puzzle-view.vala"
		if (self->priv->tiles_handle_init_done) {
#line 389 "puzzle-view.c"
			gint height = 0;
			gint _tmp2_;
			gint _tmp3_;
			gint width = 0;
			gint _tmp4_;
			gint _tmp5_;
			cairo_surface_t* _tmp6_;
			cairo_surface_t* _tmp7_;
			cairo_t* c = NULL;
			cairo_surface_t* _tmp8_;
			cairo_t* _tmp9_;
			gdouble sfw = 0.0;
			gdouble sfh = 0.0;
			cairo_t* _tmp10_;
			RsvgHandle* _tmp11_;
			cairo_t* _tmp12_;
#line 130 "../src/puzzle-view.vala"
			_tmp2_ = puzzle_view_get_tile_size (self);
#line 130 "../src/puzzle-view.vala"
			_tmp3_ = _tmp2_;
#line 130 "../src/puzzle-view.vala"
			height = _tmp3_ * 2;
#line 131 "../src/puzzle-view.vala"
			_tmp4_ = puzzle_view_get_tile_size (self);
#line 131 "../src/puzzle-view.vala"
			_tmp5_ = _tmp4_;
#line 131 "../src/puzzle-view.vala"
			width = _tmp5_ * PUZZLE_VIEW_THEME_TILE_SEGMENTS;
#line 133 "../src/puzzle-view.vala"
			_tmp6_ = cairo_get_target (cr);
#line 133 "../src/puzzle-view.vala"
			_tmp7_ = cairo_surface_create_similar (_tmp6_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
#line 133 "../src/puzzle-view.vala"
			_cairo_surface_destroy0 (self->priv->surface);
#line 133 "../src/puzzle-view.vala"
			self->priv->surface = _tmp7_;
#line 134 "../src/puzzle-view.vala"
			_tmp8_ = self->priv->surface;
#line 134 "../src/puzzle-view.vala"
			_tmp9_ = cairo_create (_tmp8_);
#line 134 "../src/puzzle-view.vala"
			c = _tmp9_;
#line 137 "../src/puzzle-view.vala"
			sfw = ((gdouble) width) / 918.0;
#line 138 "../src/puzzle-view.vala"
			sfh = ((gdouble) height) / 68.0;
#line 140 "../src/puzzle-view.vala"
			_tmp10_ = c;
#line 140 "../src/puzzle-view.vala"
			cairo_scale (_tmp10_, sfw, sfh);
#line 142 "../src/puzzle-view.vala"
			_tmp11_ = self->priv->tiles_handle;
#line 142 "../src/puzzle-view.vala"
			_tmp12_ = c;
#line 142 "../src/puzzle-view.vala"
			rsvg_handle_render_cairo (_tmp11_, _tmp12_);
#line 128 "../src/puzzle-view.vala"
			_cairo_destroy0 (c);
#line 448 "puzzle-view.c"
		}
#line 144 "../src/puzzle-view.vala"
		_tmp13_ = puzzle_view_get_tile_size (self);
#line 144 "../src/puzzle-view.vala"
		_tmp14_ = _tmp13_;
#line 144 "../src/puzzle-view.vala"
		self->priv->render_size = _tmp14_;
#line 456 "puzzle-view.c"
	}
#line 147 "../src/puzzle-view.vala"
	_tmp15_ = self->priv->style_context;
#line 147 "../src/puzzle-view.vala"
	gtk_style_context_save (_tmp15_);
#line 148 "../src/puzzle-view.vala"
	_tmp16_ = self->priv->style_context;
#line 148 "../src/puzzle-view.vala"
	gtk_style_context_set_state (_tmp16_, GTK_STATE_FLAG_NORMAL);
#line 149 "../src/puzzle-view.vala"
	_tmp17_ = self->priv->style_context;
#line 149 "../src/puzzle-view.vala"
	gtk_style_context_get_color (_tmp17_, GTK_STATE_FLAG_NORMAL, &_tmp18_);
#line 149 "../src/puzzle-view.vala"
	fg = _tmp18_;
#line 150 "../src/puzzle-view.vala"
	_tmp19_ = self->priv->style_context;
#line 150 "../src/puzzle-view.vala"
	gtk_style_context_get_background_color (_tmp19_, GTK_STATE_FLAG_NORMAL, &_tmp20_);
#line 150 "../src/puzzle-view.vala"
	bg = _tmp20_;
#line 151 "../src/puzzle-view.vala"
	_tmp21_ = self->priv->style_context;
#line 151 "../src/puzzle-view.vala"
	gtk_style_context_restore (_tmp21_);
#line 153 "../src/puzzle-view.vala"
	_tmp22_ = bg;
#line 153 "../src/puzzle-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp22_);
#line 154 "../src/puzzle-view.vala"
	cairo_paint (cr);
#line 156 "../src/puzzle-view.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 157 "../src/puzzle-view.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 159 "../src/puzzle-view.vala"
	_tmp23_ = fg;
#line 159 "../src/puzzle-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp23_);
#line 160 "../src/puzzle-view.vala"
	cairo_set_line_width (cr, 1.0);
#line 162 "../src/puzzle-view.vala"
	_tmp24_ = puzzle_view_get_puzzle (self);
#line 162 "../src/puzzle-view.vala"
	_tmp25_ = _tmp24_;
#line 162 "../src/puzzle-view.vala"
	_tmp26_ = puzzle_get_width (_tmp25_);
#line 162 "../src/puzzle-view.vala"
	_tmp27_ = _tmp26_;
#line 162 "../src/puzzle-view.vala"
	_tmp28_ = puzzle_view_get_tile_size (self);
#line 162 "../src/puzzle-view.vala"
	_tmp29_ = _tmp28_;
#line 162 "../src/puzzle-view.vala"
	kwidth = ((_tmp27_ * _tmp29_) + PUZZLE_VIEW_SPACE_PADDING) - 2.0;
#line 163 "../src/puzzle-view.vala"
	_tmp30_ = puzzle_view_get_puzzle (self);
#line 163 "../src/puzzle-view.vala"
	_tmp31_ = _tmp30_;
#line 163 "../src/puzzle-view.vala"
	_tmp32_ = puzzle_get_height (_tmp31_);
#line 163 "../src/puzzle-view.vala"
	_tmp33_ = _tmp32_;
#line 163 "../src/puzzle-view.vala"
	_tmp34_ = puzzle_view_get_tile_size (self);
#line 163 "../src/puzzle-view.vala"
	_tmp35_ = _tmp34_;
#line 163 "../src/puzzle-view.vala"
	kheight = ((_tmp33_ * _tmp35_) + PUZZLE_VIEW_SPACE_PADDING) - 2.0;
#line 164 "../src/puzzle-view.vala"
	self->priv->kx = (width - kwidth) / 2.0;
#line 165 "../src/puzzle-view.vala"
	self->priv->ky = (height - kheight) / 2.0;
#line 167 "../src/puzzle-view.vala"
	cairo_rectangle (cr, self->priv->kx, self->priv->ky, kwidth, kheight);
#line 168 "../src/puzzle-view.vala"
	cairo_stroke (cr);
#line 534 "puzzle-view.c"
	{
		guint8 y = 0U;
#line 170 "../src/puzzle-view.vala"
		y = (guint8) 0;
#line 539 "puzzle-view.c"
		{
			gboolean _tmp36_ = FALSE;
#line 170 "../src/puzzle-view.vala"
			_tmp36_ = TRUE;
#line 170 "../src/puzzle-view.vala"
			while (TRUE) {
#line 546 "puzzle-view.c"
				Puzzle* _tmp38_;
				Puzzle* _tmp39_;
				guint8 _tmp40_;
				guint8 _tmp41_;
#line 170 "../src/puzzle-view.vala"
				if (!_tmp36_) {
#line 553 "puzzle-view.c"
					guint8 _tmp37_;
#line 170 "../src/puzzle-view.vala"
					_tmp37_ = y;
#line 170 "../src/puzzle-view.vala"
					y = _tmp37_ + 1;
#line 559 "puzzle-view.c"
				}
#line 170 "../src/puzzle-view.vala"
				_tmp36_ = FALSE;
#line 170 "../src/puzzle-view.vala"
				_tmp38_ = puzzle_view_get_puzzle (self);
#line 170 "../src/puzzle-view.vala"
				_tmp39_ = _tmp38_;
#line 170 "../src/puzzle-view.vala"
				_tmp40_ = puzzle_get_height (_tmp39_);
#line 170 "../src/puzzle-view.vala"
				_tmp41_ = _tmp40_;
#line 170 "../src/puzzle-view.vala"
				if (!(y < _tmp41_)) {
#line 170 "../src/puzzle-view.vala"
					break;
#line 575 "puzzle-view.c"
				}
				{
					guint8 x = 0U;
#line 171 "../src/puzzle-view.vala"
					x = (guint8) 0;
#line 581 "puzzle-view.c"
					{
						gboolean _tmp42_ = FALSE;
#line 171 "../src/puzzle-view.vala"
						_tmp42_ = TRUE;
#line 171 "../src/puzzle-view.vala"
						while (TRUE) {
#line 588 "puzzle-view.c"
							Puzzle* _tmp44_;
							Puzzle* _tmp45_;
							guint8 _tmp46_;
							guint8 _tmp47_;
							gchar _tmp48_;
							gchar _tmp49_;
							Puzzle* _tmp50_;
							Puzzle* _tmp51_;
							Puzzle* _tmp52_;
							Puzzle* _tmp53_;
							gchar* _tmp54_;
							gint _tmp54__length1;
#line 171 "../src/puzzle-view.vala"
							if (!_tmp42_) {
#line 603 "puzzle-view.c"
								guint8 _tmp43_;
#line 171 "../src/puzzle-view.vala"
								_tmp43_ = x;
#line 171 "../src/puzzle-view.vala"
								x = _tmp43_ + 1;
#line 609 "puzzle-view.c"
							}
#line 171 "../src/puzzle-view.vala"
							_tmp42_ = FALSE;
#line 171 "../src/puzzle-view.vala"
							_tmp44_ = puzzle_view_get_puzzle (self);
#line 171 "../src/puzzle-view.vala"
							_tmp45_ = _tmp44_;
#line 171 "../src/puzzle-view.vala"
							_tmp46_ = puzzle_get_width (_tmp45_);
#line 171 "../src/puzzle-view.vala"
							_tmp47_ = _tmp46_;
#line 171 "../src/puzzle-view.vala"
							if (!(x < _tmp47_)) {
#line 171 "../src/puzzle-view.vala"
								break;
#line 625 "puzzle-view.c"
							}
#line 173 "../src/puzzle-view.vala"
							puzzle_view_draw_square (self, cr, x, y, self->priv->kx, self->priv->ky);
#line 175 "../src/puzzle-view.vala"
							_tmp48_ = puzzle_view_get_piece_id (self);
#line 175 "../src/puzzle-view.vala"
							_tmp49_ = _tmp48_;
#line 175 "../src/puzzle-view.vala"
							_tmp50_ = puzzle_view_get_puzzle (self);
#line 175 "../src/puzzle-view.vala"
							_tmp51_ = _tmp50_;
#line 175 "../src/puzzle-view.vala"
							_tmp52_ = puzzle_view_get_puzzle (self);
#line 175 "../src/puzzle-view.vala"
							_tmp53_ = _tmp52_;
#line 175 "../src/puzzle-view.vala"
							_tmp54_ = _tmp53_->map;
#line 175 "../src/puzzle-view.vala"
							_tmp54__length1 = _tmp53_->map_length1;
#line 175 "../src/puzzle-view.vala"
							if (_tmp49_ == puzzle_get_piece_id (_tmp51_, _tmp54_, (gint) _tmp54__length1, x, y)) {
#line 647 "puzzle-view.c"
								GdkRGBA _tmp55_ = {0};
								gint _tmp56_;
								gint _tmp57_;
								gint _tmp58_;
								gint _tmp59_;
								gint _tmp60_;
								gint _tmp61_;
								gint _tmp62_;
								gint _tmp63_;
#line 177 "../src/puzzle-view.vala"
								_tmp55_.red = 1.0;
#line 177 "../src/puzzle-view.vala"
								_tmp55_.green = 1.0;
#line 177 "../src/puzzle-view.vala"
								_tmp55_.blue = 1.0;
#line 177 "../src/puzzle-view.vala"
								_tmp55_.alpha = 0.2;
#line 177 "../src/puzzle-view.vala"
								gdk_cairo_set_source_rgba (cr, &_tmp55_);
#line 178 "../src/puzzle-view.vala"
								_tmp56_ = puzzle_view_get_tile_size (self);
#line 178 "../src/puzzle-view.vala"
								_tmp57_ = _tmp56_;
#line 178 "../src/puzzle-view.vala"
								_tmp58_ = puzzle_view_get_tile_size (self);
#line 178 "../src/puzzle-view.vala"
								_tmp59_ = _tmp58_;
#line 178 "../src/puzzle-view.vala"
								_tmp60_ = puzzle_view_get_tile_size (self);
#line 178 "../src/puzzle-view.vala"
								_tmp61_ = _tmp60_;
#line 178 "../src/puzzle-view.vala"
								_tmp62_ = puzzle_view_get_tile_size (self);
#line 178 "../src/puzzle-view.vala"
								_tmp63_ = _tmp62_;
#line 178 "../src/puzzle-view.vala"
								cairo_rectangle (cr, (x * _tmp57_) + self->priv->kx, (y * _tmp59_) + self->priv->ky, (gdouble) _tmp61_, (gdouble) _tmp63_);
#line 179 "../src/puzzle-view.vala"
								cairo_fill (cr);
#line 687 "puzzle-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 183 "../src/puzzle-view.vala"
	result = FALSE;
#line 183 "../src/puzzle-view.vala"
	return result;
#line 699 "puzzle-view.c"
}

static void
puzzle_view_draw_square (PuzzleView* self,
                         cairo_t* cr,
                         guint8 x,
                         guint8 y,
                         gdouble kx,
                         gdouble ky)
{
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GdkRGBA bg = {0};
	GtkStyleContext* _tmp10_;
	GdkRGBA _tmp11_ = {0};
	GtkStyleContext* _tmp12_;
	GdkRectangle _tmp13_;
	GdkRGBA _tmp14_;
	Puzzle* _tmp15_;
	Puzzle* _tmp16_;
	Puzzle* _tmp17_;
	Puzzle* _tmp18_;
	gchar* _tmp19_;
	gint _tmp19__length1;
	Puzzle* _tmp30_;
	Puzzle* _tmp31_;
	Puzzle* _tmp32_;
	Puzzle* _tmp33_;
	gchar* _tmp34_;
	gint _tmp34__length1;
#line 186 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/puzzle-view.vala"
	g_return_if_fail (cr != NULL);
#line 188 "../src/puzzle-view.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 189 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_tile_size (self);
#line 189 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 189 "../src/puzzle-view.vala"
	rect.x = (((x * _tmp1_) + PUZZLE_VIEW_SPACE_OFFSET) + ((gint) kx)) - 1;
#line 190 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_view_get_tile_size (self);
#line 190 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 190 "../src/puzzle-view.vala"
	rect.y = (((y * _tmp3_) + PUZZLE_VIEW_SPACE_OFFSET) + ((gint) ky)) - 1;
#line 191 "../src/puzzle-view.vala"
	_tmp4_ = puzzle_view_get_tile_size (self);
#line 191 "../src/puzzle-view.vala"
	_tmp5_ = _tmp4_;
#line 191 "../src/puzzle-view.vala"
	rect.width = _tmp5_;
#line 192 "../src/puzzle-view.vala"
	_tmp6_ = puzzle_view_get_tile_size (self);
#line 192 "../src/puzzle-view.vala"
	_tmp7_ = _tmp6_;
#line 192 "../src/puzzle-view.vala"
	rect.height = _tmp7_;
#line 194 "../src/puzzle-view.vala"
	_tmp8_ = self->priv->style_context;
#line 194 "../src/puzzle-view.vala"
	gtk_style_context_save (_tmp8_);
#line 195 "../src/puzzle-view.vala"
	_tmp9_ = self->priv->style_context;
#line 195 "../src/puzzle-view.vala"
	gtk_style_context_set_state (_tmp9_, GTK_STATE_FLAG_NORMAL);
#line 196 "../src/puzzle-view.vala"
	_tmp10_ = self->priv->style_context;
#line 196 "../src/puzzle-view.vala"
	gtk_style_context_get_background_color (_tmp10_, GTK_STATE_FLAG_NORMAL, &_tmp11_);
#line 196 "../src/puzzle-view.vala"
	bg = _tmp11_;
#line 197 "../src/puzzle-view.vala"
	_tmp12_ = self->priv->style_context;
#line 197 "../src/puzzle-view.vala"
	gtk_style_context_restore (_tmp12_);
#line 199 "../src/puzzle-view.vala"
	_tmp13_ = rect;
#line 199 "../src/puzzle-view.vala"
	gdk_cairo_rectangle (cr, &_tmp13_);
#line 200 "../src/puzzle-view.vala"
	_tmp14_ = bg;
#line 200 "../src/puzzle-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp14_);
#line 202 "../src/puzzle-view.vala"
	cairo_fill (cr);
#line 204 "../src/puzzle-view.vala"
	_tmp15_ = puzzle_view_get_puzzle (self);
#line 204 "../src/puzzle-view.vala"
	_tmp16_ = _tmp15_;
#line 204 "../src/puzzle-view.vala"
	_tmp17_ = puzzle_view_get_puzzle (self);
#line 204 "../src/puzzle-view.vala"
	_tmp18_ = _tmp17_;
#line 204 "../src/puzzle-view.vala"
	_tmp19_ = _tmp18_->map;
#line 204 "../src/puzzle-view.vala"
	_tmp19__length1 = _tmp18_->map_length1;
#line 204 "../src/puzzle-view.vala"
	if (puzzle_get_piece_id (_tmp16_, _tmp19_, (gint) _tmp19__length1, x, y) != ' ') {
#line 811 "puzzle-view.c"
		GdkRectangle _tmp20_;
		cairo_surface_t* _tmp21_;
		GdkRectangle _tmp22_;
		Puzzle* _tmp23_;
		Puzzle* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		GdkRectangle _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
#line 206 "../src/puzzle-view.vala"
		_tmp20_ = rect;
#line 206 "../src/puzzle-view.vala"
		gdk_cairo_rectangle (cr, &_tmp20_);
#line 207 "../src/puzzle-view.vala"
		_tmp21_ = self->priv->surface;
#line 207 "../src/puzzle-view.vala"
		_tmp22_ = rect;
#line 207 "../src/puzzle-view.vala"
		_tmp23_ = puzzle_view_get_puzzle (self);
#line 207 "../src/puzzle-view.vala"
		_tmp24_ = _tmp23_;
#line 207 "../src/puzzle-view.vala"
		_tmp25_ = puzzle_view_get_tile_size (self);
#line 207 "../src/puzzle-view.vala"
		_tmp26_ = _tmp25_;
#line 207 "../src/puzzle-view.vala"
		_tmp27_ = rect;
#line 207 "../src/puzzle-view.vala"
		_tmp28_ = puzzle_view_get_tile_size (self);
#line 207 "../src/puzzle-view.vala"
		_tmp29_ = _tmp28_;
#line 207 "../src/puzzle-view.vala"
		cairo_set_source_surface (cr, _tmp21_, (gdouble) (_tmp22_.x - (puzzle_get_piece_nr (_tmp24_, x, y) * _tmp26_)), (gdouble) (_tmp27_.y - (_tmp29_ / 2)));
#line 208 "../src/puzzle-view.vala"
		cairo_fill (cr);
#line 848 "puzzle-view.c"
	}
#line 211 "../src/puzzle-view.vala"
	_tmp30_ = puzzle_view_get_puzzle (self);
#line 211 "../src/puzzle-view.vala"
	_tmp31_ = _tmp30_;
#line 211 "../src/puzzle-view.vala"
	_tmp32_ = puzzle_view_get_puzzle (self);
#line 211 "../src/puzzle-view.vala"
	_tmp33_ = _tmp32_;
#line 211 "../src/puzzle-view.vala"
	_tmp34_ = _tmp33_->map;
#line 211 "../src/puzzle-view.vala"
	_tmp34__length1 = _tmp33_->map_length1;
#line 211 "../src/puzzle-view.vala"
	if (puzzle_get_piece_id (_tmp31_, _tmp34_, (gint) _tmp34__length1, x, y) == '*') {
#line 864 "puzzle-view.c"
		guint8 tile_value = 0U;
		Puzzle* _tmp35_;
		Puzzle* _tmp36_;
		Puzzle* _tmp37_;
		Puzzle* _tmp38_;
		gchar* _tmp39_;
		gint _tmp39__length1;
		gint overlay_size = 0;
		gint _tmp40_;
		gint _tmp41_;
		gint overlay_offset = 0;
		gint _tmp42_;
		gint _tmp43_;
		GdkRectangle _tmp44_;
		GdkRectangle _tmp45_;
		cairo_surface_t* _tmp46_;
		GdkRectangle _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		GdkRectangle _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
#line 213 "../src/puzzle-view.vala"
		tile_value = (guint8) 22;
#line 214 "../src/puzzle-view.vala"
		_tmp35_ = puzzle_view_get_puzzle (self);
#line 214 "../src/puzzle-view.vala"
		_tmp36_ = _tmp35_;
#line 214 "../src/puzzle-view.vala"
		_tmp37_ = puzzle_view_get_puzzle (self);
#line 214 "../src/puzzle-view.vala"
		_tmp38_ = _tmp37_;
#line 214 "../src/puzzle-view.vala"
		_tmp39_ = _tmp38_->orig_map;
#line 214 "../src/puzzle-view.vala"
		_tmp39__length1 = _tmp38_->orig_map_length1;
#line 214 "../src/puzzle-view.vala"
		if (puzzle_get_piece_id (_tmp36_, _tmp39_, (gint) _tmp39__length1, x, y) == '.') {
#line 215 "../src/puzzle-view.vala"
			tile_value = (guint8) 20;
#line 905 "puzzle-view.c"
		}
#line 217 "../src/puzzle-view.vala"
		_tmp40_ = puzzle_view_get_tile_size (self);
#line 217 "../src/puzzle-view.vala"
		_tmp41_ = _tmp40_;
#line 217 "../src/puzzle-view.vala"
		overlay_size = (PUZZLE_VIEW_THEME_OVERLAY_SIZE * _tmp41_) / PUZZLE_VIEW_THEME_TILE_SIZE;
#line 218 "../src/puzzle-view.vala"
		_tmp42_ = puzzle_view_get_tile_size (self);
#line 218 "../src/puzzle-view.vala"
		_tmp43_ = _tmp42_;
#line 218 "../src/puzzle-view.vala"
		overlay_offset = ((PUZZLE_VIEW_THEME_TILE_CENTER * _tmp43_) / PUZZLE_VIEW_THEME_TILE_SIZE) - (overlay_size / 2);
#line 220 "../src/puzzle-view.vala"
		_tmp44_ = rect;
#line 220 "../src/puzzle-view.vala"
		_tmp45_ = rect;
#line 220 "../src/puzzle-view.vala"
		cairo_rectangle (cr, (gdouble) (_tmp44_.x + overlay_offset), (gdouble) (_tmp45_.y + overlay_offset), (gdouble) overlay_size, (gdouble) overlay_size);
#line 223 "../src/puzzle-view.vala"
		_tmp46_ = self->priv->surface;
#line 223 "../src/puzzle-view.vala"
		_tmp47_ = rect;
#line 223 "../src/puzzle-view.vala"
		_tmp48_ = puzzle_view_get_tile_size (self);
#line 223 "../src/puzzle-view.vala"
		_tmp49_ = _tmp48_;
#line 223 "../src/puzzle-view.vala"
		_tmp50_ = rect;
#line 223 "../src/puzzle-view.vala"
		_tmp51_ = puzzle_view_get_tile_size (self);
#line 223 "../src/puzzle-view.vala"
		_tmp52_ = _tmp51_;
#line 223 "../src/puzzle-view.vala"
		cairo_set_source_surface (cr, _tmp46_, (gdouble) (_tmp47_.x - (tile_value * _tmp49_)), (gdouble) (_tmp50_.y - (_tmp52_ / 2)));
#line 224 "../src/puzzle-view.vala"
		cairo_fill (cr);
#line 943 "puzzle-view.c"
	}
}

static void
_puzzle_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 238 "../src/puzzle-view.vala"
	puzzle_view_on_motion (_sender, x, y);
#line 955 "puzzle-view.c"
}

static void
_puzzle_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                       gint n_press,
                                                       gdouble x,
                                                       gdouble y,
                                                       gpointer self)
{
#line 241 "../src/puzzle-view.vala"
	puzzle_view_on_click (_sender, n_press, x, y);
#line 967 "puzzle-view.c"
}

static void
_puzzle_view_on_release_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                          gint n_press,
                                                          gdouble x,
                                                          gdouble y,
                                                          gpointer self)
{
#line 242 "../src/puzzle-view.vala"
	puzzle_view_on_release (_sender, n_press, x, y);
#line 979 "puzzle-view.c"
}

static void
puzzle_view_init_mouse (PuzzleView* self)
{
	GtkEventControllerMotion* _tmp0_;
	GtkEventControllerMotion* _tmp1_;
	GtkGestureMultiPress* _tmp2_;
	GtkGestureMultiPress* _tmp3_;
	GtkGestureMultiPress* _tmp4_;
#line 235 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/puzzle-view.vala"
	_tmp0_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
#line 237 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 237 "../src/puzzle-view.vala"
	self->priv->motion_controller = _tmp0_;
#line 238 "../src/puzzle-view.vala"
	_tmp1_ = self->priv->motion_controller;
#line 238 "../src/puzzle-view.vala"
	g_signal_connect (_tmp1_, "motion", (GCallback) _puzzle_view_on_motion_gtk_event_controller_motion_motion, NULL);
#line 240 "../src/puzzle-view.vala"
	_tmp2_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 240 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 240 "../src/puzzle-view.vala"
	self->priv->click_controller = _tmp2_;
#line 241 "../src/puzzle-view.vala"
	_tmp3_ = self->priv->click_controller;
#line 241 "../src/puzzle-view.vala"
	g_signal_connect (_tmp3_, "pressed", (GCallback) _puzzle_view_on_click_gtk_gesture_multi_press_pressed, NULL);
#line 242 "../src/puzzle-view.vala"
	_tmp4_ = self->priv->click_controller;
#line 242 "../src/puzzle-view.vala"
	g_signal_connect (_tmp4_, "released", (GCallback) _puzzle_view_on_release_gtk_gesture_multi_press_released, NULL);
#line 1016 "puzzle-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 247 "../src/puzzle-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 1024 "puzzle-view.c"
}

static gchar*
_vala_array_dup7 (gchar* self,
                  gssize length)
{
#line 278 "../src/puzzle-view.vala"
	if (length > 0) {
#line 278 "../src/puzzle-view.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1035 "puzzle-view.c"
	}
#line 278 "../src/puzzle-view.vala"
	return NULL;
#line 1039 "puzzle-view.c"
}

static inline void
puzzle_view_on_click (GtkGestureMultiPress* _click_controller,
                      gint n_press,
                      gdouble event_x,
                      gdouble event_y)
{
	PuzzleView* _this = NULL;
	GtkWidget* _tmp0_;
	PuzzleView* _tmp1_;
	PuzzleView* _tmp2_;
	Puzzle* _tmp3_;
	Puzzle* _tmp4_;
	gint new_piece_x = 0;
	PuzzleView* _tmp5_;
	PuzzleView* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint new_piece_y = 0;
	PuzzleView* _tmp9_;
	PuzzleView* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	PuzzleView* _tmp26_;
	PuzzleView* _tmp27_;
	gchar new_piece_id = '\0';
	PuzzleView* _tmp28_;
	Puzzle* _tmp29_;
	Puzzle* _tmp30_;
	PuzzleView* _tmp31_;
	Puzzle* _tmp32_;
	Puzzle* _tmp33_;
	gchar* _tmp34_;
	gint _tmp34__length1;
	PuzzleView* _tmp35_;
	PuzzleView* _tmp36_;
	gboolean already_moving = FALSE;
	PuzzleView* _tmp37_;
	gchar _tmp38_;
	gchar _tmp39_;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp43_ = FALSE;
	PuzzleView* _tmp51_;
	PuzzleView* _tmp52_;
	PuzzleView* _tmp53_;
	Puzzle* _tmp54_;
	Puzzle* _tmp55_;
	PuzzleView* _tmp56_;
	Puzzle* _tmp57_;
	Puzzle* _tmp58_;
	gchar* _tmp59_;
	gint _tmp59__length1;
	gchar* _tmp60_;
	gint _tmp60__length1;
#line 245 "../src/puzzle-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 247 "../src/puzzle-view.vala"
	_tmp0_ = gtk_event_controller_get_widget ((GtkEventController*) _click_controller);
#line 247 "../src/puzzle-view.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PUZZLE_VIEW, PuzzleView));
#line 247 "../src/puzzle-view.vala"
	_this = _tmp1_;
#line 248 "../src/puzzle-view.vala"
	_tmp2_ = _this;
#line 248 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_view_get_puzzle (_tmp2_);
#line 248 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 248 "../src/puzzle-view.vala"
	if (puzzle_game_over (_tmp4_)) {
#line 249 "../src/puzzle-view.vala"
		_g_object_unref0 (_this);
#line 249 "../src/puzzle-view.vala"
		return;
#line 1118 "puzzle-view.c"
	}
#line 251 "../src/puzzle-view.vala"
	_tmp5_ = _this;
#line 251 "../src/puzzle-view.vala"
	_tmp6_ = _this;
#line 251 "../src/puzzle-view.vala"
	_tmp7_ = puzzle_view_get_tile_size (_tmp6_);
#line 251 "../src/puzzle-view.vala"
	_tmp8_ = _tmp7_;
#line 251 "../src/puzzle-view.vala"
	new_piece_x = ((gint) (event_x - _tmp5_->priv->kx)) / _tmp8_;
#line 252 "../src/puzzle-view.vala"
	_tmp9_ = _this;
#line 252 "../src/puzzle-view.vala"
	_tmp10_ = _this;
#line 252 "../src/puzzle-view.vala"
	_tmp11_ = puzzle_view_get_tile_size (_tmp10_);
#line 252 "../src/puzzle-view.vala"
	_tmp12_ = _tmp11_;
#line 252 "../src/puzzle-view.vala"
	new_piece_y = ((gint) (event_y - _tmp9_->priv->ky)) / _tmp12_;
#line 253 "../src/puzzle-view.vala"
	if (new_piece_x < 0) {
#line 253 "../src/puzzle-view.vala"
		_tmp15_ = TRUE;
#line 1144 "puzzle-view.c"
	} else {
		PuzzleView* _tmp16_;
		Puzzle* _tmp17_;
		Puzzle* _tmp18_;
		guint8 _tmp19_;
		guint8 _tmp20_;
#line 253 "../src/puzzle-view.vala"
		_tmp16_ = _this;
#line 253 "../src/puzzle-view.vala"
		_tmp17_ = puzzle_view_get_puzzle (_tmp16_);
#line 253 "../src/puzzle-view.vala"
		_tmp18_ = _tmp17_;
#line 253 "../src/puzzle-view.vala"
		_tmp19_ = puzzle_get_width (_tmp18_);
#line 253 "../src/puzzle-view.vala"
		_tmp20_ = _tmp19_;
#line 253 "../src/puzzle-view.vala"
		_tmp15_ = new_piece_x >= ((gint) _tmp20_);
#line 1163 "puzzle-view.c"
	}
#line 253 "../src/puzzle-view.vala"
	if (_tmp15_) {
#line 253 "../src/puzzle-view.vala"
		_tmp14_ = TRUE;
#line 1169 "puzzle-view.c"
	} else {
#line 254 "../src/puzzle-view.vala"
		_tmp14_ = new_piece_y < 0;
#line 1173 "puzzle-view.c"
	}
#line 253 "../src/puzzle-view.vala"
	if (_tmp14_) {
#line 253 "../src/puzzle-view.vala"
		_tmp13_ = TRUE;
#line 1179 "puzzle-view.c"
	} else {
		PuzzleView* _tmp21_;
		Puzzle* _tmp22_;
		Puzzle* _tmp23_;
		guint8 _tmp24_;
		guint8 _tmp25_;
#line 254 "../src/puzzle-view.vala"
		_tmp21_ = _this;
#line 254 "../src/puzzle-view.vala"
		_tmp22_ = puzzle_view_get_puzzle (_tmp21_);
#line 254 "../src/puzzle-view.vala"
		_tmp23_ = _tmp22_;
#line 254 "../src/puzzle-view.vala"
		_tmp24_ = puzzle_get_height (_tmp23_);
#line 254 "../src/puzzle-view.vala"
		_tmp25_ = _tmp24_;
#line 254 "../src/puzzle-view.vala"
		_tmp13_ = new_piece_y >= ((gint) _tmp25_);
#line 1198 "puzzle-view.c"
	}
#line 253 "../src/puzzle-view.vala"
	if (_tmp13_) {
#line 255 "../src/puzzle-view.vala"
		_g_object_unref0 (_this);
#line 255 "../src/puzzle-view.vala"
		return;
#line 1206 "puzzle-view.c"
	}
#line 256 "../src/puzzle-view.vala"
	_tmp26_ = _this;
#line 256 "../src/puzzle-view.vala"
	_tmp26_->priv->piece_x = (guint8) new_piece_x;
#line 257 "../src/puzzle-view.vala"
	_tmp27_ = _this;
#line 257 "../src/puzzle-view.vala"
	_tmp27_->priv->piece_y = (guint8) new_piece_y;
#line 258 "../src/puzzle-view.vala"
	_tmp28_ = _this;
#line 258 "../src/puzzle-view.vala"
	_tmp29_ = puzzle_view_get_puzzle (_tmp28_);
#line 258 "../src/puzzle-view.vala"
	_tmp30_ = _tmp29_;
#line 258 "../src/puzzle-view.vala"
	_tmp31_ = _this;
#line 258 "../src/puzzle-view.vala"
	_tmp32_ = puzzle_view_get_puzzle (_tmp31_);
#line 258 "../src/puzzle-view.vala"
	_tmp33_ = _tmp32_;
#line 258 "../src/puzzle-view.vala"
	_tmp34_ = _tmp33_->map;
#line 258 "../src/puzzle-view.vala"
	_tmp34__length1 = _tmp33_->map_length1;
#line 258 "../src/puzzle-view.vala"
	_tmp35_ = _this;
#line 258 "../src/puzzle-view.vala"
	_tmp36_ = _this;
#line 258 "../src/puzzle-view.vala"
	new_piece_id = puzzle_get_piece_id (_tmp30_, _tmp34_, (gint) _tmp34__length1, _tmp35_->priv->piece_x, _tmp36_->priv->piece_y);
#line 260 "../src/puzzle-view.vala"
	_tmp37_ = _this;
#line 260 "../src/puzzle-view.vala"
	_tmp38_ = puzzle_view_get_piece_id (_tmp37_);
#line 260 "../src/puzzle-view.vala"
	_tmp39_ = _tmp38_;
#line 260 "../src/puzzle-view.vala"
	already_moving = _tmp39_ != '\0';
#line 261 "../src/puzzle-view.vala"
	if (already_moving) {
#line 1248 "puzzle-view.c"
		PuzzleView* _tmp41_;
#line 261 "../src/puzzle-view.vala"
		_tmp41_ = _this;
#line 261 "../src/puzzle-view.vala"
		_tmp40_ = _tmp41_->priv->piece_unmoved;
#line 1254 "puzzle-view.c"
	} else {
#line 261 "../src/puzzle-view.vala"
		_tmp40_ = FALSE;
#line 1258 "puzzle-view.c"
	}
#line 261 "../src/puzzle-view.vala"
	if (_tmp40_) {
#line 1262 "puzzle-view.c"
		PuzzleView* _tmp42_;
#line 263 "../src/puzzle-view.vala"
		_tmp42_ = _this;
#line 263 "../src/puzzle-view.vala"
		puzzle_view_set_piece_id (_tmp42_, '\0');
#line 264 "../src/puzzle-view.vala"
		_g_object_unref0 (_this);
#line 264 "../src/puzzle-view.vala"
		return;
#line 1272 "puzzle-view.c"
	}
#line 266 "../src/puzzle-view.vala"
	if (puzzle_is_static_tile (new_piece_id)) {
#line 266 "../src/puzzle-view.vala"
		_tmp43_ = TRUE;
#line 1278 "puzzle-view.c"
	} else {
		PuzzleView* _tmp44_;
		gchar _tmp45_;
		gchar _tmp46_;
#line 266 "../src/puzzle-view.vala"
		_tmp44_ = _this;
#line 266 "../src/puzzle-view.vala"
		_tmp45_ = puzzle_view_get_piece_id (_tmp44_);
#line 266 "../src/puzzle-view.vala"
		_tmp46_ = _tmp45_;
#line 266 "../src/puzzle-view.vala"
		_tmp43_ = new_piece_id == _tmp46_;
#line 1291 "puzzle-view.c"
	}
#line 266 "../src/puzzle-view.vala"
	if (_tmp43_) {
#line 267 "../src/puzzle-view.vala"
		_g_object_unref0 (_this);
#line 267 "../src/puzzle-view.vala"
		return;
#line 1299 "puzzle-view.c"
	}
#line 269 "../src/puzzle-view.vala"
	if (already_moving) {
#line 1303 "puzzle-view.c"
		PuzzleView* _tmp47_;
		PuzzleView* _tmp48_;
		Puzzle* _tmp49_;
		Puzzle* _tmp50_;
#line 271 "../src/puzzle-view.vala"
		_tmp47_ = _this;
#line 271 "../src/puzzle-view.vala"
		puzzle_view_validate_move (_tmp47_);
#line 272 "../src/puzzle-view.vala"
		_tmp48_ = _this;
#line 272 "../src/puzzle-view.vala"
		_tmp49_ = puzzle_view_get_puzzle (_tmp48_);
#line 272 "../src/puzzle-view.vala"
		_tmp50_ = _tmp49_;
#line 272 "../src/puzzle-view.vala"
		if (!puzzle_can_be_moved (_tmp50_, new_piece_id)) {
#line 273 "../src/puzzle-view.vala"
			_g_object_unref0 (_this);
#line 273 "../src/puzzle-view.vala"
			return;
#line 1324 "puzzle-view.c"
		}
	}
#line 276 "../src/puzzle-view.vala"
	_tmp51_ = _this;
#line 276 "../src/puzzle-view.vala"
	_tmp51_->priv->piece_unmoved = TRUE;
#line 277 "../src/puzzle-view.vala"
	_tmp52_ = _this;
#line 277 "../src/puzzle-view.vala"
	puzzle_view_set_piece_id (_tmp52_, new_piece_id);
#line 278 "../src/puzzle-view.vala"
	_tmp53_ = _this;
#line 278 "../src/puzzle-view.vala"
	_tmp54_ = puzzle_view_get_puzzle (_tmp53_);
#line 278 "../src/puzzle-view.vala"
	_tmp55_ = _tmp54_;
#line 278 "../src/puzzle-view.vala"
	_tmp56_ = _this;
#line 278 "../src/puzzle-view.vala"
	_tmp57_ = puzzle_view_get_puzzle (_tmp56_);
#line 278 "../src/puzzle-view.vala"
	_tmp58_ = _tmp57_;
#line 278 "../src/puzzle-view.vala"
	_tmp59_ = _tmp58_->map;
#line 278 "../src/puzzle-view.vala"
	_tmp59__length1 = _tmp58_->map_length1;
#line 278 "../src/puzzle-view.vala"
	_tmp60_ = (_tmp59_ != NULL) ? _vala_array_dup7 (_tmp59_, _tmp59__length1) : _tmp59_;
#line 278 "../src/puzzle-view.vala"
	_tmp60__length1 = _tmp59__length1;
#line 278 "../src/puzzle-view.vala"
	_tmp55_->move_map = (g_free (_tmp55_->move_map), NULL);
#line 278 "../src/puzzle-view.vala"
	_tmp55_->move_map = _tmp60_;
#line 278 "../src/puzzle-view.vala"
	_tmp55_->move_map_length1 = _tmp60__length1;
#line 278 "../src/puzzle-view.vala"
	_tmp55_->_move_map_size_ = _tmp55_->move_map_length1;
#line 245 "../src/puzzle-view.vala"
	_g_object_unref0 (_this);
#line 1365 "puzzle-view.c"
}

static inline void
puzzle_view_on_release (GtkGestureMultiPress* _click_controller,
                        gint n_press,
                        gdouble event_x,
                        gdouble event_y)
{
	PuzzleView* _this = NULL;
	GtkWidget* _tmp0_;
	PuzzleView* _tmp1_;
	PuzzleView* _tmp2_;
	gchar _tmp3_;
	gchar _tmp4_;
#line 281 "../src/puzzle-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 283 "../src/puzzle-view.vala"
	_tmp0_ = gtk_event_controller_get_widget ((GtkEventController*) _click_controller);
#line 283 "../src/puzzle-view.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PUZZLE_VIEW, PuzzleView));
#line 283 "../src/puzzle-view.vala"
	_this = _tmp1_;
#line 284 "../src/puzzle-view.vala"
	_tmp2_ = _this;
#line 284 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_view_get_piece_id (_tmp2_);
#line 284 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 284 "../src/puzzle-view.vala"
	if (_tmp4_ != '\0') {
#line 1396 "puzzle-view.c"
		PuzzleView* _tmp5_;
#line 285 "../src/puzzle-view.vala"
		_tmp5_ = _this;
#line 285 "../src/puzzle-view.vala"
		puzzle_view_validate_move (_tmp5_);
#line 1402 "puzzle-view.c"
	}
#line 281 "../src/puzzle-view.vala"
	_g_object_unref0 (_this);
#line 1406 "puzzle-view.c"
}

static gchar*
_vala_array_dup8 (gchar* self,
                  gssize length)
{
#line 297 "../src/puzzle-view.vala"
	if (length > 0) {
#line 297 "../src/puzzle-view.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1417 "puzzle-view.c"
	}
#line 297 "../src/puzzle-view.vala"
	return NULL;
#line 1421 "puzzle-view.c"
}

static gchar*
_vala_array_dup9 (gchar* self,
                  gssize length)
{
#line 310 "../src/puzzle-view.vala"
	if (length > 0) {
#line 310 "../src/puzzle-view.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1432 "puzzle-view.c"
	}
#line 310 "../src/puzzle-view.vala"
	return NULL;
#line 1436 "puzzle-view.c"
}

static void
puzzle_view_validate_move (PuzzleView* self)
{
	gboolean _tmp0_ = FALSE;
	gchar _tmp1_;
	gchar _tmp2_;
#line 288 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/puzzle-view.vala"
	if (self->priv->piece_unmoved) {
#line 291 "../src/puzzle-view.vala"
		return;
#line 1451 "puzzle-view.c"
	}
#line 293 "../src/puzzle-view.vala"
	_tmp1_ = puzzle_view_get_piece_id (self);
#line 293 "../src/puzzle-view.vala"
	_tmp2_ = _tmp1_;
#line 293 "../src/puzzle-view.vala"
	if (!puzzle_is_static_tile (_tmp2_)) {
#line 1459 "puzzle-view.c"
		Puzzle* _tmp3_;
		Puzzle* _tmp4_;
		Puzzle* _tmp5_;
		Puzzle* _tmp6_;
		gchar* _tmp7_;
		gint _tmp7__length1;
		Puzzle* _tmp8_;
		Puzzle* _tmp9_;
		gchar* _tmp10_;
		gint _tmp10__length1;
#line 293 "../src/puzzle-view.vala"
		_tmp3_ = puzzle_view_get_puzzle (self);
#line 293 "../src/puzzle-view.vala"
		_tmp4_ = _tmp3_;
#line 293 "../src/puzzle-view.vala"
		_tmp5_ = puzzle_view_get_puzzle (self);
#line 293 "../src/puzzle-view.vala"
		_tmp6_ = _tmp5_;
#line 293 "../src/puzzle-view.vala"
		_tmp7_ = _tmp6_->move_map;
#line 293 "../src/puzzle-view.vala"
		_tmp7__length1 = _tmp6_->move_map_length1;
#line 293 "../src/puzzle-view.vala"
		_tmp8_ = puzzle_view_get_puzzle (self);
#line 293 "../src/puzzle-view.vala"
		_tmp9_ = _tmp8_;
#line 293 "../src/puzzle-view.vala"
		_tmp10_ = _tmp9_->map;
#line 293 "../src/puzzle-view.vala"
		_tmp10__length1 = _tmp9_->map_length1;
#line 293 "../src/puzzle-view.vala"
		_tmp0_ = puzzle_mapcmp (_tmp4_, _tmp7_, (gint) _tmp7__length1, _tmp10_, (gint) _tmp10__length1);
#line 1492 "puzzle-view.c"
	} else {
#line 293 "../src/puzzle-view.vala"
		_tmp0_ = FALSE;
#line 1496 "puzzle-view.c"
	}
#line 293 "../src/puzzle-view.vala"
	if (_tmp0_) {
#line 1500 "puzzle-view.c"
		gboolean _tmp11_ = FALSE;
		gboolean _tmp28_ = FALSE;
		Puzzle* _tmp29_;
		Puzzle* _tmp30_;
		guint16 _tmp31_;
		guint16 _tmp32_;
		Puzzle* _tmp47_;
		Puzzle* _tmp48_;
		Puzzle* _tmp49_;
		Puzzle* _tmp50_;
		gchar* _tmp51_;
		gint _tmp51__length1;
		gchar* _tmp52_;
		gint _tmp52__length1;
		Puzzle* _tmp53_;
		Puzzle* _tmp54_;
#line 295 "../src/puzzle-view.vala"
		if (self->priv->last_piece_id == '\0') {
#line 295 "../src/puzzle-view.vala"
			_tmp11_ = TRUE;
#line 1521 "puzzle-view.c"
		} else {
			gchar _tmp12_;
			gchar _tmp13_;
#line 295 "../src/puzzle-view.vala"
			_tmp12_ = puzzle_view_get_piece_id (self);
#line 295 "../src/puzzle-view.vala"
			_tmp13_ = _tmp12_;
#line 295 "../src/puzzle-view.vala"
			_tmp11_ = self->priv->last_piece_id != _tmp13_;
#line 1531 "puzzle-view.c"
		}
#line 295 "../src/puzzle-view.vala"
		if (_tmp11_) {
#line 1535 "puzzle-view.c"
			Puzzle* _tmp14_;
			Puzzle* _tmp15_;
			Puzzle* _tmp16_;
			Puzzle* _tmp17_;
			gchar* _tmp18_;
			gint _tmp18__length1;
			gchar* _tmp19_;
			gint _tmp19__length1;
			Puzzle* _tmp20_;
			Puzzle* _tmp21_;
			guint16 _tmp22_;
			guint16 _tmp23_;
#line 297 "../src/puzzle-view.vala"
			_tmp14_ = puzzle_view_get_puzzle (self);
#line 297 "../src/puzzle-view.vala"
			_tmp15_ = _tmp14_;
#line 297 "../src/puzzle-view.vala"
			_tmp16_ = puzzle_view_get_puzzle (self);
#line 297 "../src/puzzle-view.vala"
			_tmp17_ = _tmp16_;
#line 297 "../src/puzzle-view.vala"
			_tmp18_ = _tmp17_->lastmove_map;
#line 297 "../src/puzzle-view.vala"
			_tmp18__length1 = _tmp17_->lastmove_map_length1;
#line 297 "../src/puzzle-view.vala"
			_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup8 (_tmp18_, _tmp18__length1) : _tmp18_;
#line 297 "../src/puzzle-view.vala"
			_tmp19__length1 = _tmp18__length1;
#line 297 "../src/puzzle-view.vala"
			_tmp15_->undomove_map = (g_free (_tmp15_->undomove_map), NULL);
#line 297 "../src/puzzle-view.vala"
			_tmp15_->undomove_map = _tmp19_;
#line 297 "../src/puzzle-view.vala"
			_tmp15_->undomove_map_length1 = _tmp19__length1;
#line 297 "../src/puzzle-view.vala"
			_tmp15_->_undomove_map_size_ = _tmp15_->undomove_map_length1;
#line 298 "../src/puzzle-view.vala"
			_tmp20_ = puzzle_view_get_puzzle (self);
#line 298 "../src/puzzle-view.vala"
			_tmp21_ = _tmp20_;
#line 298 "../src/puzzle-view.vala"
			_tmp22_ = puzzle_get_moves (_tmp21_);
#line 298 "../src/puzzle-view.vala"
			_tmp23_ = _tmp22_;
#line 298 "../src/puzzle-view.vala"
			if (((gint) _tmp23_) < 10000) {
#line 1582 "puzzle-view.c"
				Puzzle* _tmp24_;
				Puzzle* _tmp25_;
				guint16 _tmp26_;
				guint16 _tmp27_;
#line 299 "../src/puzzle-view.vala"
				_tmp24_ = puzzle_view_get_puzzle (self);
#line 299 "../src/puzzle-view.vala"
				_tmp25_ = _tmp24_;
#line 299 "../src/puzzle-view.vala"
				_tmp26_ = puzzle_get_moves (_tmp25_);
#line 299 "../src/puzzle-view.vala"
				_tmp27_ = _tmp26_;
#line 299 "../src/puzzle-view.vala"
				puzzle_set_moves (_tmp25_, _tmp27_ + 1);
#line 1597 "puzzle-view.c"
			}
		}
#line 302 "../src/puzzle-view.vala"
		_tmp29_ = puzzle_view_get_puzzle (self);
#line 302 "../src/puzzle-view.vala"
		_tmp30_ = _tmp29_;
#line 302 "../src/puzzle-view.vala"
		_tmp31_ = puzzle_get_moves (_tmp30_);
#line 302 "../src/puzzle-view.vala"
		_tmp32_ = _tmp31_;
#line 302 "../src/puzzle-view.vala"
		if (((gint) _tmp32_) > 0) {
#line 1610 "puzzle-view.c"
			Puzzle* _tmp33_;
			Puzzle* _tmp34_;
			Puzzle* _tmp35_;
			Puzzle* _tmp36_;
			gchar* _tmp37_;
			gint _tmp37__length1;
			Puzzle* _tmp38_;
			Puzzle* _tmp39_;
			gchar* _tmp40_;
			gint _tmp40__length1;
#line 302 "../src/puzzle-view.vala"
			_tmp33_ = puzzle_view_get_puzzle (self);
#line 302 "../src/puzzle-view.vala"
			_tmp34_ = _tmp33_;
#line 302 "../src/puzzle-view.vala"
			_tmp35_ = puzzle_view_get_puzzle (self);
#line 302 "../src/puzzle-view.vala"
			_tmp36_ = _tmp35_;
#line 302 "../src/puzzle-view.vala"
			_tmp37_ = _tmp36_->undomove_map;
#line 302 "../src/puzzle-view.vala"
			_tmp37__length1 = _tmp36_->undomove_map_length1;
#line 302 "../src/puzzle-view.vala"
			_tmp38_ = puzzle_view_get_puzzle (self);
#line 302 "../src/puzzle-view.vala"
			_tmp39_ = _tmp38_;
#line 302 "../src/puzzle-view.vala"
			_tmp40_ = _tmp39_->map;
#line 302 "../src/puzzle-view.vala"
			_tmp40__length1 = _tmp39_->map_length1;
#line 302 "../src/puzzle-view.vala"
			_tmp28_ = !puzzle_mapcmp (_tmp34_, _tmp37_, (gint) _tmp37__length1, _tmp40_, (gint) _tmp40__length1);
#line 1643 "puzzle-view.c"
		} else {
#line 302 "../src/puzzle-view.vala"
			_tmp28_ = FALSE;
#line 1647 "puzzle-view.c"
		}
#line 302 "../src/puzzle-view.vala"
		if (_tmp28_) {
#line 1651 "puzzle-view.c"
			Puzzle* _tmp41_;
			Puzzle* _tmp42_;
			guint16 _tmp43_;
			guint16 _tmp44_;
#line 304 "../src/puzzle-view.vala"
			_tmp41_ = puzzle_view_get_puzzle (self);
#line 304 "../src/puzzle-view.vala"
			_tmp42_ = _tmp41_;
#line 304 "../src/puzzle-view.vala"
			_tmp43_ = puzzle_get_moves (_tmp42_);
#line 304 "../src/puzzle-view.vala"
			_tmp44_ = _tmp43_;
#line 304 "../src/puzzle-view.vala"
			puzzle_set_moves (_tmp42_, _tmp44_ - 1);
#line 305 "../src/puzzle-view.vala"
			self->priv->last_piece_id = '\0';
#line 1668 "puzzle-view.c"
		} else {
			gchar _tmp45_;
			gchar _tmp46_;
#line 308 "../src/puzzle-view.vala"
			_tmp45_ = puzzle_view_get_piece_id (self);
#line 308 "../src/puzzle-view.vala"
			_tmp46_ = _tmp45_;
#line 308 "../src/puzzle-view.vala"
			self->priv->last_piece_id = _tmp46_;
#line 1678 "puzzle-view.c"
		}
#line 310 "../src/puzzle-view.vala"
		_tmp47_ = puzzle_view_get_puzzle (self);
#line 310 "../src/puzzle-view.vala"
		_tmp48_ = _tmp47_;
#line 310 "../src/puzzle-view.vala"
		_tmp49_ = puzzle_view_get_puzzle (self);
#line 310 "../src/puzzle-view.vala"
		_tmp50_ = _tmp49_;
#line 310 "../src/puzzle-view.vala"
		_tmp51_ = _tmp50_->map;
#line 310 "../src/puzzle-view.vala"
		_tmp51__length1 = _tmp50_->map_length1;
#line 310 "../src/puzzle-view.vala"
		_tmp52_ = (_tmp51_ != NULL) ? _vala_array_dup9 (_tmp51_, _tmp51__length1) : _tmp51_;
#line 310 "../src/puzzle-view.vala"
		_tmp52__length1 = _tmp51__length1;
#line 310 "../src/puzzle-view.vala"
		_tmp48_->lastmove_map = (g_free (_tmp48_->lastmove_map), NULL);
#line 310 "../src/puzzle-view.vala"
		_tmp48_->lastmove_map = _tmp52_;
#line 310 "../src/puzzle-view.vala"
		_tmp48_->lastmove_map_length1 = _tmp52__length1;
#line 310 "../src/puzzle-view.vala"
		_tmp48_->_lastmove_map_size_ = _tmp48_->lastmove_map_length1;
#line 312 "../src/puzzle-view.vala"
		_tmp53_ = puzzle_view_get_puzzle (self);
#line 312 "../src/puzzle-view.vala"
		_tmp54_ = _tmp53_;
#line 312 "../src/puzzle-view.vala"
		g_signal_emit_by_name (_tmp54_, "moved");
#line 1710 "puzzle-view.c"
	}
#line 314 "../src/puzzle-view.vala"
	puzzle_view_set_piece_id (self, '\0');
#line 1714 "puzzle-view.c"
}

static inline void
puzzle_view_on_motion (GtkEventControllerMotion* _motion_controller,
                       gdouble event_x,
                       gdouble event_y)
{
	PuzzleView* _this = NULL;
	GtkWidget* _tmp0_;
	PuzzleView* _tmp1_;
	PuzzleView* _tmp2_;
	gchar _tmp3_;
	gchar _tmp4_;
#line 317 "../src/puzzle-view.vala"
	g_return_if_fail (_motion_controller != NULL);
#line 319 "../src/puzzle-view.vala"
	_tmp0_ = gtk_event_controller_get_widget ((GtkEventController*) _motion_controller);
#line 319 "../src/puzzle-view.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PUZZLE_VIEW, PuzzleView));
#line 319 "../src/puzzle-view.vala"
	_this = _tmp1_;
#line 320 "../src/puzzle-view.vala"
	_tmp2_ = _this;
#line 320 "../src/puzzle-view.vala"
	_tmp3_ = puzzle_view_get_piece_id (_tmp2_);
#line 320 "../src/puzzle-view.vala"
	_tmp4_ = _tmp3_;
#line 320 "../src/puzzle-view.vala"
	if (_tmp4_ != '\0') {
#line 1744 "puzzle-view.c"
		gint new_piece_x = 0;
		PuzzleView* _tmp5_;
		PuzzleView* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint new_piece_y = 0;
		PuzzleView* _tmp9_;
		PuzzleView* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		PuzzleView* _tmp26_;
		Puzzle* _tmp27_;
		Puzzle* _tmp28_;
		PuzzleView* _tmp29_;
		gchar _tmp30_;
		gchar _tmp31_;
		PuzzleView* _tmp32_;
		PuzzleView* _tmp33_;
#line 322 "../src/puzzle-view.vala"
		_tmp5_ = _this;
#line 322 "../src/puzzle-view.vala"
		_tmp6_ = _this;
#line 322 "../src/puzzle-view.vala"
		_tmp7_ = puzzle_view_get_tile_size (_tmp6_);
#line 322 "../src/puzzle-view.vala"
		_tmp8_ = _tmp7_;
#line 322 "../src/puzzle-view.vala"
		new_piece_x = ((gint) (event_x - _tmp5_->priv->kx)) / _tmp8_;
#line 323 "../src/puzzle-view.vala"
		_tmp9_ = _this;
#line 323 "../src/puzzle-view.vala"
		_tmp10_ = _this;
#line 323 "../src/puzzle-view.vala"
		_tmp11_ = puzzle_view_get_tile_size (_tmp10_);
#line 323 "../src/puzzle-view.vala"
		_tmp12_ = _tmp11_;
#line 323 "../src/puzzle-view.vala"
		new_piece_y = ((gint) (event_y - _tmp9_->priv->ky)) / _tmp12_;
#line 324 "../src/puzzle-view.vala"
		if (event_x < ((gdouble) 0)) {
#line 324 "../src/puzzle-view.vala"
			_tmp15_ = TRUE;
#line 1790 "puzzle-view.c"
		} else {
			PuzzleView* _tmp16_;
			Puzzle* _tmp17_;
			Puzzle* _tmp18_;
			guint8 _tmp19_;
			guint8 _tmp20_;
#line 324 "../src/puzzle-view.vala"
			_tmp16_ = _this;
#line 324 "../src/puzzle-view.vala"
			_tmp17_ = puzzle_view_get_puzzle (_tmp16_);
#line 324 "../src/puzzle-view.vala"
			_tmp18_ = _tmp17_;
#line 324 "../src/puzzle-view.vala"
			_tmp19_ = puzzle_get_width (_tmp18_);
#line 324 "../src/puzzle-view.vala"
			_tmp20_ = _tmp19_;
#line 324 "../src/puzzle-view.vala"
			_tmp15_ = new_piece_x > ((gint) _tmp20_);
#line 1809 "puzzle-view.c"
		}
#line 324 "../src/puzzle-view.vala"
		if (_tmp15_) {
#line 324 "../src/puzzle-view.vala"
			_tmp14_ = TRUE;
#line 1815 "puzzle-view.c"
		} else {
#line 325 "../src/puzzle-view.vala"
			_tmp14_ = event_y < ((gdouble) 0);
#line 1819 "puzzle-view.c"
		}
#line 324 "../src/puzzle-view.vala"
		if (_tmp14_) {
#line 324 "../src/puzzle-view.vala"
			_tmp13_ = TRUE;
#line 1825 "puzzle-view.c"
		} else {
			PuzzleView* _tmp21_;
			Puzzle* _tmp22_;
			Puzzle* _tmp23_;
			guint8 _tmp24_;
			guint8 _tmp25_;
#line 325 "../src/puzzle-view.vala"
			_tmp21_ = _this;
#line 325 "../src/puzzle-view.vala"
			_tmp22_ = puzzle_view_get_puzzle (_tmp21_);
#line 325 "../src/puzzle-view.vala"
			_tmp23_ = _tmp22_;
#line 325 "../src/puzzle-view.vala"
			_tmp24_ = puzzle_get_height (_tmp23_);
#line 325 "../src/puzzle-view.vala"
			_tmp25_ = _tmp24_;
#line 325 "../src/puzzle-view.vala"
			_tmp13_ = new_piece_y > ((gint) _tmp25_);
#line 1844 "puzzle-view.c"
		}
#line 324 "../src/puzzle-view.vala"
		if (_tmp13_) {
#line 326 "../src/puzzle-view.vala"
			_g_object_unref0 (_this);
#line 326 "../src/puzzle-view.vala"
			return;
#line 1852 "puzzle-view.c"
		}
#line 327 "../src/puzzle-view.vala"
		_tmp26_ = _this;
#line 327 "../src/puzzle-view.vala"
		_tmp27_ = puzzle_view_get_puzzle (_tmp26_);
#line 327 "../src/puzzle-view.vala"
		_tmp28_ = _tmp27_;
#line 327 "../src/puzzle-view.vala"
		_tmp29_ = _this;
#line 327 "../src/puzzle-view.vala"
		_tmp30_ = puzzle_view_get_piece_id (_tmp29_);
#line 327 "../src/puzzle-view.vala"
		_tmp31_ = _tmp30_;
#line 327 "../src/puzzle-view.vala"
		_tmp32_ = _this;
#line 327 "../src/puzzle-view.vala"
		_tmp33_ = _this;
#line 327 "../src/puzzle-view.vala"
		if (puzzle_move_piece (_tmp28_, _tmp31_, _tmp32_->priv->piece_x, _tmp33_->priv->piece_y, (guint8) new_piece_x, (guint8) new_piece_y)) {
#line 1872 "puzzle-view.c"
			PuzzleView* _tmp34_;
			PuzzleView* _tmp35_;
			PuzzleView* _tmp36_;
#line 329 "../src/puzzle-view.vala"
			_tmp34_ = _this;
#line 329 "../src/puzzle-view.vala"
			_tmp34_->priv->piece_unmoved = FALSE;
#line 330 "../src/puzzle-view.vala"
			_tmp35_ = _this;
#line 330 "../src/puzzle-view.vala"
			_tmp35_->priv->piece_x = (guint8) new_piece_x;
#line 331 "../src/puzzle-view.vala"
			_tmp36_ = _this;
#line 331 "../src/puzzle-view.vala"
			_tmp36_->priv->piece_y = (guint8) new_piece_y;
#line 1888 "puzzle-view.c"
		}
	}
#line 317 "../src/puzzle-view.vala"
	_g_object_unref0 (_this);
#line 1893 "puzzle-view.c"
}

PuzzleView*
puzzle_view_construct (GType object_type)
{
	PuzzleView * self = NULL;
#line 20 "../src/puzzle-view.vala"
	self = (PuzzleView*) g_object_new (object_type, NULL);
#line 20 "../src/puzzle-view.vala"
	return self;
#line 1904 "puzzle-view.c"
}

PuzzleView*
puzzle_view_new (void)
{
#line 20 "../src/puzzle-view.vala"
	return puzzle_view_construct (TYPE_PUZZLE_VIEW);
#line 1912 "puzzle-view.c"
}

static gchar
puzzle_view_get_piece_id (PuzzleView* self)
{
	gchar result;
#line 38 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 38 "../src/puzzle-view.vala"
	result = self->priv->_piece_id;
#line 38 "../src/puzzle-view.vala"
	return result;
#line 1925 "puzzle-view.c"
}

static void
puzzle_view_set_piece_id (PuzzleView* self,
                          gchar value)
{
#line 39 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/puzzle-view.vala"
	self->priv->_piece_id = value;
#line 39 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1938 "puzzle-view.c"
}

static Puzzle*
puzzle_view_get_puzzle (PuzzleView* self)
{
	Puzzle* result;
	Puzzle* _tmp0_;
#line 56 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/puzzle-view.vala"
	if (!self->priv->puzzle_init_done) {
#line 56 "../src/puzzle-view.vala"
		g_assert_not_reached ();
#line 1952 "puzzle-view.c"
	}
#line 56 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->_puzzle;
#line 56 "../src/puzzle-view.vala"
	result = _tmp0_;
#line 56 "../src/puzzle-view.vala"
	return result;
#line 1960 "puzzle-view.c"
}

static void
_gtk_widget_queue_draw_puzzle_changed (Puzzle* _sender,
                                       gpointer self)
{
#line 62 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1969 "puzzle-view.c"
}

void
puzzle_view_set_puzzle (PuzzleView* self,
                        Puzzle* value)
{
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
#line 57 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/puzzle-view.vala"
	if (self->priv->puzzle_init_done) {
#line 1982 "puzzle-view.c"
		Puzzle* _tmp0_;
#line 60 "../src/puzzle-view.vala"
		_tmp0_ = self->priv->_puzzle;
#line 60 "../src/puzzle-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp0_, NULL, self);
#line 1988 "puzzle-view.c"
	}
#line 61 "../src/puzzle-view.vala"
	_tmp1_ = _g_object_ref0 (value);
#line 61 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->_puzzle);
#line 61 "../src/puzzle-view.vala"
	self->priv->_puzzle = _tmp1_;
#line 62 "../src/puzzle-view.vala"
	_tmp2_ = self->priv->_puzzle;
#line 62 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp2_, "changed", (GCallback) _gtk_widget_queue_draw_puzzle_changed, (GtkWidget*) self, 0);
#line 63 "../src/puzzle-view.vala"
	self->priv->puzzle_init_done = TRUE;
#line 64 "../src/puzzle-view.vala"
	self->priv->piece_x = (guint8) 0;
#line 65 "../src/puzzle-view.vala"
	self->priv->piece_y = (guint8) 0;
#line 66 "../src/puzzle-view.vala"
	self->priv->piece_unmoved = FALSE;
#line 67 "../src/puzzle-view.vala"
	puzzle_view_set_piece_id (self, '\0');
#line 68 "../src/puzzle-view.vala"
	self->priv->last_piece_id = '\0';
#line 69 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 57 "../src/puzzle-view.vala"
	g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_PUZZLE_PROPERTY]);
#line 2016 "puzzle-view.c"
}

static gint
puzzle_view_get_tile_size (PuzzleView* self)
{
	gint result;
	gint s = 0;
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	Puzzle* _tmp4_;
	Puzzle* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
#line 91 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 93 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 93 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 93 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_get_width (_tmp1_);
#line 93 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 93 "../src/puzzle-view.vala"
	_tmp4_ = puzzle_view_get_puzzle (self);
#line 93 "../src/puzzle-view.vala"
	_tmp5_ = _tmp4_;
#line 93 "../src/puzzle-view.vala"
	_tmp6_ = puzzle_get_height (_tmp5_);
#line 93 "../src/puzzle-view.vala"
	_tmp7_ = _tmp6_;
#line 93 "../src/puzzle-view.vala"
	s = MIN ((gtk_widget_get_allocated_width ((GtkWidget*) self) - PUZZLE_VIEW_SPACE_PADDING) / _tmp3_, (gtk_widget_get_allocated_height ((GtkWidget*) self) - PUZZLE_VIEW_SPACE_PADDING) / _tmp7_);
#line 95 "../src/puzzle-view.vala"
	if ((s % 2) != 0) {
#line 2054 "puzzle-view.c"
		gint _tmp8_;
#line 96 "../src/puzzle-view.vala"
		_tmp8_ = s;
#line 96 "../src/puzzle-view.vala"
		s = _tmp8_ - 1;
#line 2060 "puzzle-view.c"
	}
#line 97 "../src/puzzle-view.vala"
	result = s;
#line 97 "../src/puzzle-view.vala"
	return result;
#line 2066 "puzzle-view.c"
}

static GObject *
puzzle_view_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PuzzleView * self;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 74 "../src/puzzle-view.vala"
	parent_class = G_OBJECT_CLASS (puzzle_view_parent_class);
#line 74 "../src/puzzle-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 74 "../src/puzzle-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE_VIEW, PuzzleView);
#line 76 "../src/puzzle-view.vala"
	puzzle_view_init_mouse (self);
#line 78 "../src/puzzle-view.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 78 "../src/puzzle-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 78 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->style_context);
#line 78 "../src/puzzle-view.vala"
	self->priv->style_context = _tmp1_;
#line 80 "../src/puzzle-view.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 250, 250);
#line 81 "../src/puzzle-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_POINTER_MOTION_MASK) | GDK_BUTTON_RELEASE_MASK));
#line 86 "../src/puzzle-view.vala"
	puzzle_view_load_image (self);
#line 74 "../src/puzzle-view.vala"
	return obj;
#line 2103 "puzzle-view.c"
}

static void
puzzle_view_class_init (PuzzleViewClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/puzzle-view.vala"
	puzzle_view_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/puzzle-view.vala"
	g_type_class_adjust_private_offset (klass, &PuzzleView_private_offset);
#line 20 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) puzzle_view_real_draw;
#line 20 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_puzzle_view_get_property;
#line 20 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_puzzle_view_set_property;
#line 20 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->constructor = puzzle_view_constructor;
#line 20 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->finalize = puzzle_view_finalize;
#line 20 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_PUZZLE_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_PUZZLE_PROPERTY] = g_param_spec_object ("puzzle", "puzzle", "puzzle", TYPE_PUZZLE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 2126 "puzzle-view.c"
}

static void
puzzle_view_instance_init (PuzzleView * self,
                           gpointer klass)
{
#line 20 "../src/puzzle-view.vala"
	self->priv = puzzle_view_get_instance_private (self);
#line 29 "../src/puzzle-view.vala"
	self->priv->render_size = 0;
#line 31 "../src/puzzle-view.vala"
	self->priv->piece_x = (guint8) 0;
#line 32 "../src/puzzle-view.vala"
	self->priv->piece_y = (guint8) 0;
#line 33 "../src/puzzle-view.vala"
	self->priv->piece_unmoved = FALSE;
#line 35 "../src/puzzle-view.vala"
	self->priv->_piece_id = '\0';
#line 42 "../src/puzzle-view.vala"
	self->priv->last_piece_id = '\0';
#line 44 "../src/puzzle-view.vala"
	self->priv->kx = (gdouble) 0;
#line 45 "../src/puzzle-view.vala"
	self->priv->ky = (gdouble) 0;
#line 47 "../src/puzzle-view.vala"
	self->priv->tiles_handle_init_done = FALSE;
#line 52 "../src/puzzle-view.vala"
	self->priv->puzzle_init_done = FALSE;
#line 2155 "puzzle-view.c"
}

static void
puzzle_view_finalize (GObject * obj)
{
	PuzzleView * self;
#line 20 "../src/puzzle-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE_VIEW, PuzzleView);
#line 48 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->tiles_handle);
#line 49 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->image_file);
#line 50 "../src/puzzle-view.vala"
	_cairo_surface_destroy0 (self->priv->surface);
#line 53 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->_puzzle);
#line 73 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->style_context);
#line 232 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 233 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 20 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (puzzle_view_parent_class)->finalize (obj);
#line 2180 "puzzle-view.c"
}

static GType
puzzle_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PuzzleViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PuzzleView), 0, (GInstanceInitFunc) puzzle_view_instance_init, NULL };
	GType puzzle_view_type_id;
	puzzle_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PuzzleView", &g_define_type_info, 0);
	PuzzleView_private_offset = g_type_add_instance_private (puzzle_view_type_id, sizeof (PuzzleViewPrivate));
	return puzzle_view_type_id;
}

GType
puzzle_view_get_type (void)
{
	static volatile gsize puzzle_view_type_id__once = 0;
	if (g_once_init_enter (&puzzle_view_type_id__once)) {
		GType puzzle_view_type_id;
		puzzle_view_type_id = puzzle_view_get_type_once ();
		g_once_init_leave (&puzzle_view_type_id__once, puzzle_view_type_id);
	}
	return puzzle_view_type_id__once;
}

static void
_vala_puzzle_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
#line 20 "../src/puzzle-view.vala"
	switch (property_id) {
#line 20 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
#line 20 "../src/puzzle-view.vala"
		g_value_set_object (value, puzzle_view_get_puzzle (self));
#line 20 "../src/puzzle-view.vala"
		break;
#line 2221 "puzzle-view.c"
		default:
#line 20 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/puzzle-view.vala"
		break;
#line 2227 "puzzle-view.c"
	}
}

static void
_vala_puzzle_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
#line 20 "../src/puzzle-view.vala"
	switch (property_id) {
#line 20 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
#line 20 "../src/puzzle-view.vala"
		puzzle_view_set_puzzle (self, g_value_get_object (value));
#line 20 "../src/puzzle-view.vala"
		break;
#line 2247 "puzzle-view.c"
		default:
#line 20 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/puzzle-view.vala"
		break;
#line 2253 "puzzle-view.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

